diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/__init__.py
index 8bda490..042077a 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/__init__.py
@@ -30,6 +30,78 @@ from pgadmin.utils.driver import get_driver
 from config import PG_DEFAULT_DRIVER
 
 
+def check_precondition(f):
+    """
+    This function will behave as a decorator which will checks
+    database connection before running view, it will also attaches
+    manager,conn & template_path properties to self
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold self & kwargs will hold gid,sid,did
+        self = args[0]
+        driver = get_driver(PG_DEFAULT_DRIVER)
+        self.manager = driver.connection_manager(kwargs['sid'])
+        self.conn = self.manager.connection(did=kwargs['did'])
+        self.qtIdent = driver.qtIdent
+        # We need datlastsysoid to check if current table is system table
+        self.datlastsysoid = self.manager.db_info[kwargs['did']]['datlastsysoid']
+
+        # If DB not connected then return error to browser
+        if not self.conn.connected():
+            return precondition_required(
+                gettext(
+                    "Connection to the server has been lost!"
+                )
+            )
+
+        # We need datlastsysoid to check if current index is system index
+        self.datlastsysoid = self.manager.db_info[kwargs['did']]['datlastsysoid']
+
+        # we will set template path for sql scripts
+        ver = self.manager.version
+        # Template for Column node
+        if ver >= 90500:
+            self.template_path = 'table/sql/9.5_plus'
+        else:
+            self.template_path = 'table/sql/9.1_plus'
+
+        # Template for Column ,check constraint and exclusion constraint node
+        if ver >= 90200:
+            self.column_template_path = 'column/sql/9.2_plus'
+            self.check_constraint_template_path = 'check_constraint/sql/9.2_plus'
+            self.exclusion_constraint_template_path = 'exclusion_constraint/sql/9.2_plus'
+        else:
+            self.column_template_path = 'column/sql/9.1_plus'
+            self.check_constraint_template_path = 'check_constraint/sql/9.1_plus'
+            self.exclusion_constraint_template_path = 'exclusion_constraint/sql/9.1_plus'
+
+        # Template for PK & Unique constraint node
+        self.index_constraint_template_path = 'index_constraint/sql'
+
+        # Template for foreign key constraint node
+        self.foreign_key_template_path = 'foreign_key/sql'
+
+        # Template for index node
+        self.index_template_path = 'index/sql/9.1_plus'
+
+        # Template for trigger node
+        self.trigger_template_path = 'trigger/sql/9.1_plus'
+
+        # Template for rules node
+        self.rules_template_path = 'rules/sql'
+
+        # Supported ACL for table
+        self.acl = ['a', 'r', 'w', 'd', 'D', 'x', 't']
+
+        # Supported ACL for columns
+        self.column_acl = ['a', 'r', 'w', 'x']
+
+        return f(*args, **kwargs)
+
+    return wrap
+
 class TableModule(SchemaChildModule):
     """
      class TableModule(SchemaChildModule)
@@ -66,11 +138,23 @@ class TableModule(SchemaChildModule):
         self.max_ver = None
         self.min_ver = None
 
+    @check_precondition
     def get_nodes(self, gid, sid, did, scid):
         """
         Generate the collection node
         """
-        yield self.generate_browser_collection_node(scid)
+        collection_count = 0
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template("/".join([self.template_path,'nodes.sql']),
+                                   scid=scid)
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
+
+        yield self.generate_browser_collection_node(scid, collection_count)
 
     @property
     def script_load(self):
@@ -260,78 +344,6 @@ class TableView(PGChildNodeView, DataTypeReader, VacuumSettings):
 
     })
 
-    def check_precondition(f):
-        """
-        This function will behave as a decorator which will checks
-        database connection before running view, it will also attaches
-        manager,conn & template_path properties to self
-        """
-
-        @wraps(f)
-        def wrap(*args, **kwargs):
-            # Here args[0] will hold self & kwargs will hold gid,sid,did
-            self = args[0]
-            driver = get_driver(PG_DEFAULT_DRIVER)
-            self.manager = driver.connection_manager(kwargs['sid'])
-            self.conn = self.manager.connection(did=kwargs['did'])
-            self.qtIdent = driver.qtIdent
-            # We need datlastsysoid to check if current table is system table
-            self.datlastsysoid = self.manager.db_info[kwargs['did']]['datlastsysoid']
-
-            # If DB not connected then return error to browser
-            if not self.conn.connected():
-                return precondition_required(
-                    gettext(
-                        "Connection to the server has been lost!"
-                    )
-                )
-
-            # We need datlastsysoid to check if current index is system index
-            self.datlastsysoid = self.manager.db_info[kwargs['did']]['datlastsysoid']
-
-            # we will set template path for sql scripts
-            ver = self.manager.version
-            # Template for Column node
-            if ver >= 90500:
-                self.template_path = 'table/sql/9.5_plus'
-            else:
-                self.template_path = 'table/sql/9.1_plus'
-
-            # Template for Column ,check constraint and exclusion constraint node
-            if ver >= 90200:
-                self.column_template_path = 'column/sql/9.2_plus'
-                self.check_constraint_template_path = 'check_constraint/sql/9.2_plus'
-                self.exclusion_constraint_template_path = 'exclusion_constraint/sql/9.2_plus'
-            else:
-                self.column_template_path = 'column/sql/9.1_plus'
-                self.check_constraint_template_path = 'check_constraint/sql/9.1_plus'
-                self.exclusion_constraint_template_path = 'exclusion_constraint/sql/9.1_plus'
-
-            # Template for PK & Unique constraint node
-            self.index_constraint_template_path = 'index_constraint/sql'
-
-            # Template for foreign key constraint node
-            self.foreign_key_template_path = 'foreign_key/sql'
-
-            # Template for index node
-            self.index_template_path = 'index/sql/9.1_plus'
-
-            # Template for trigger node
-            self.trigger_template_path = 'trigger/sql/9.1_plus'
-
-            # Template for rules node
-            self.rules_template_path = 'rules/sql'
-
-            # Supported ACL for table
-            self.acl = ['a', 'r', 'w', 'd', 'D', 'x', 't']
-
-            # Supported ACL for columns
-            self.column_acl = ['a', 'r', 'w', 'x']
-
-            return f(*args, **kwargs)
-
-        return wrap
-
     @check_precondition
     def list(self, gid, sid, did, scid):
         """
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/__init__.py
index ef5cbe4..3c9c4e0 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/__init__.py
@@ -28,6 +28,56 @@ from pgadmin.utils.driver import get_driver
 
 from config import PG_DEFAULT_DRIVER
 
+def check_precondition(f):
+    """
+    This function will behave as a decorator which will checks
+    database connection before running view, it will also attaches
+    manager,conn & template_path properties to self
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold self & kwargs will hold gid,sid,did
+        self = args[0]
+        driver = get_driver(PG_DEFAULT_DRIVER)
+        self.manager = driver.connection_manager(
+            kwargs['sid']
+        )
+        self.conn = self.manager.connection(did=kwargs['did'])
+        self.qtIdent = driver.qtIdent
+        # If DB not connected then return error to browser
+        if not self.conn.connected():
+            return precondition_required(
+                gettext(
+                    "Connection to the server has been lost!"
+                )
+            )
+
+        ver = self.manager.version
+        # we will set template path for sql scripts
+        if ver >= 90200:
+            self.template_path = 'column/sql/9.2_plus'
+        else:
+            self.template_path = 'column/sql/9.1_plus'
+        # Allowed ACL for column 'Select/Update/Insert/References'
+        self.acl = ['a', 'r', 'w', 'x']
+
+        # We need parent's name eg table name and schema name
+        SQL = render_template("/".join([self.template_path,
+                                        'get_parent.sql']),
+                              tid=kwargs['tid'])
+        status, rset = self.conn.execute_2darray(SQL)
+        if not status:
+            return internal_server_error(errormsg=rset)
+
+        for row in rset['rows']:
+            self.schema = row['schema']
+            self.table = row['table']
+
+        return f(*args, **kwargs)
+
+    return wrap
+
 
 class ColumnsModule(CollectionNodeModule):
     """
@@ -66,13 +116,26 @@ class ColumnsModule(CollectionNodeModule):
         self.max_ver = None
         super(ColumnsModule, self).__init__(*args, **kwargs)
 
+    @check_precondition
     def get_nodes(self, gid, sid, did, scid, **kwargs):
         """
         Generate the collection node
         """
+        collection_count = 0
+        _id = kwargs['tid'] if 'tid' in kwargs else kwargs['vid']
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template("/".join([self.template_path, 'nodes.sql']),
+                                   tid=_id, show_sys_objects=self.show_system_objects)
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
+
         assert ('tid' in kwargs or 'vid' in kwargs)
         yield self.generate_browser_collection_node(
-            kwargs['tid'] if 'tid' in kwargs else kwargs['vid']
+            kwargs['tid'] if 'tid' in kwargs else kwargs['vid'], collection_count
         )
 
     @property
@@ -182,56 +245,6 @@ class ColumnsView(PGChildNodeView, DataTypeReader):
         'module.js': [{}, {}, {'get': 'module_js'}],
     })
 
-    def check_precondition(f):
-        """
-        This function will behave as a decorator which will checks
-        database connection before running view, it will also attaches
-        manager,conn & template_path properties to self
-        """
-
-        @wraps(f)
-        def wrap(*args, **kwargs):
-            # Here args[0] will hold self & kwargs will hold gid,sid,did
-            self = args[0]
-            driver = get_driver(PG_DEFAULT_DRIVER)
-            self.manager = driver.connection_manager(
-                kwargs['sid']
-            )
-            self.conn = self.manager.connection(did=kwargs['did'])
-            self.qtIdent = driver.qtIdent
-            # If DB not connected then return error to browser
-            if not self.conn.connected():
-                return precondition_required(
-                    gettext(
-                        "Connection to the server has been lost!"
-                    )
-                )
-
-            ver = self.manager.version
-            # we will set template path for sql scripts
-            if ver >= 90200:
-                self.template_path = 'column/sql/9.2_plus'
-            else:
-                self.template_path = 'column/sql/9.1_plus'
-            # Allowed ACL for column 'Select/Update/Insert/References'
-            self.acl = ['a', 'r', 'w', 'x']
-
-            # We need parent's name eg table name and schema name
-            SQL = render_template("/".join([self.template_path,
-                                            'get_parent.sql']),
-                                  tid=kwargs['tid'])
-            status, rset = self.conn.execute_2darray(SQL)
-            if not status:
-                return internal_server_error(errormsg=rset)
-
-            for row in rset['rows']:
-                self.schema = row['schema']
-                self.table = row['table']
-
-            return f(*args, **kwargs)
-
-        return wrap
-
     @check_precondition
     def list(self, gid, sid, did, scid, tid):
         """
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/__init__.py
index a82ee5a..c10d6b5 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/__init__.py
@@ -49,11 +49,18 @@ class ConstraintsModule(CollectionNodeModule):
         self.max_ver = None
         super(ConstraintsModule, self).__init__(*args, **kwargs)
 
-    def get_nodes(self, gid, sid, did, scid, tid):
+    def get_nodes(self, **kwargs):
         """
         Generate the collection node
         """
-        yield self.generate_browser_collection_node(tid)
+        cmd = {"cmd": "nodes"}
+        constraints = []
+        for name in ConstraintRegistry.registry:
+            module = (ConstraintRegistry.registry[name])['nodeview']
+            view = module(**cmd)
+            constraints = constraints + view.get_nodes(**kwargs)
+
+        yield self.generate_browser_collection_node(kwargs['tid'], len(constraints))
 
     @property
     def script_load(self):
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/__init__.py
index d79c946..c2ba3c0 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/__init__.py
@@ -24,6 +24,53 @@ from pgadmin.utils.driver import get_driver
 
 from config import PG_DEFAULT_DRIVER
 
+def check_precondition(f):
+    """
+    This function will behave as a decorator which will checks
+    database connection before running view, it will also attaches
+    manager,conn & template_path properties to self
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold self & kwargs will hold gid,sid,did
+        self = args[0]
+        self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(
+            kwargs['sid']
+        )
+        self.conn = self.manager.connection(did=kwargs['did'])
+        # If DB not connected then return error to browser
+        if not self.conn.connected():
+            return precondition_required(
+                gettext(
+                    "Connection to the server has been lost!"
+                )
+            )
+
+        # We need datlastsysoid to check if current index is system index
+        self.datlastsysoid = self.manager.db_info[kwargs['did']]['datlastsysoid']
+
+        # we will set template path for sql scripts
+        self.template_path = 'index/sql/9.1_plus'
+
+        # We need parent's name eg table name and schema name
+        # when we create new index in update we can fetch it using
+        # property sql
+        SQL = render_template("/".join([self.template_path,
+                                        'get_parent.sql']),
+                              tid=kwargs['tid'])
+        status, rset = self.conn.execute_2darray(SQL)
+        if not status:
+            return internal_server_error(errormsg=rset)
+
+        for row in rset['rows']:
+            self.schema = row['schema']
+            self.table = row['table']
+
+        return f(*args, **kwargs)
+
+    return wrap
+
 
 class IndexesModule(CollectionNodeModule):
     """
@@ -92,13 +139,26 @@ class IndexesModule(CollectionNodeModule):
             # then true, othewise false
             return res
 
+    @check_precondition
     def get_nodes(self, gid, sid, did, scid, **kwargs):
         """
         Generate the collection node
         """
+        collection_count = 0
+        _id = kwargs['tid'] if 'tid' in kwargs else kwargs['vid']
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template("/".join([self.template_path,
+                                        'nodes.sql']), tid=_id)
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
+
         assert ('tid' in kwargs or 'vid' in kwargs)
         yield self.generate_browser_collection_node(
-            kwargs['tid'] if 'tid' in kwargs else kwargs['vid']
+            kwargs['tid'] if 'tid' in kwargs else kwargs['vid'], collection_count
         )
 
     @property
@@ -213,53 +273,6 @@ class IndexesView(PGChildNodeView):
                          {'get': 'get_op_class'}]
     })
 
-    def check_precondition(f):
-        """
-        This function will behave as a decorator which will checks
-        database connection before running view, it will also attaches
-        manager,conn & template_path properties to self
-        """
-
-        @wraps(f)
-        def wrap(*args, **kwargs):
-            # Here args[0] will hold self & kwargs will hold gid,sid,did
-            self = args[0]
-            self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(
-                kwargs['sid']
-            )
-            self.conn = self.manager.connection(did=kwargs['did'])
-            # If DB not connected then return error to browser
-            if not self.conn.connected():
-                return precondition_required(
-                    gettext(
-                        "Connection to the server has been lost!"
-                    )
-                )
-
-            # We need datlastsysoid to check if current index is system index
-            self.datlastsysoid = self.manager.db_info[kwargs['did']]['datlastsysoid']
-
-            # we will set template path for sql scripts
-            self.template_path = 'index/sql/9.1_plus'
-
-            # We need parent's name eg table name and schema name
-            # when we create new index in update we can fetch it using
-            # property sql
-            SQL = render_template("/".join([self.template_path,
-                                            'get_parent.sql']),
-                                  tid=kwargs['tid'])
-            status, rset = self.conn.execute_2darray(SQL)
-            if not status:
-                return internal_server_error(errormsg=rset)
-
-            for row in rset['rows']:
-                self.schema = row['schema']
-                self.table = row['table']
-
-            return f(*args, **kwargs)
-
-        return wrap
-
     @check_precondition
     def get_collations(self, gid, sid, did, scid, tid, idx=None):
         """
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/rules/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/rules/__init__.py
index d462454..3e77338 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/rules/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/rules/__init__.py
@@ -26,6 +26,34 @@ from pgadmin.utils.driver import get_driver
 
 from config import PG_DEFAULT_DRIVER
 
+def check_precondition(f):
+    """
+    This function will behave as a decorator which will check the
+    database connection before running a view. It will also attach
+    manager, conn & template_path properties to self
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold self & kwargs will hold gid,sid,did
+        self = args[0]
+        self.manager = get_driver(
+            PG_DEFAULT_DRIVER).connection_manager(kwargs['sid'])
+        self.conn = self.manager.connection(did=kwargs['did'])
+
+        # If DB not connected then return error to browser
+        if not self.conn.connected():
+            return precondition_required(
+                gettext(
+                    "Connection to the server has been lost!"
+                )
+            )
+
+        self.datlastsysoid = self.manager.db_info[kwargs['did']]['datlastsysoid']
+        self.template_path = 'rules/sql'
+        return f(*args, **kwargs)
+
+    return wrap
 
 class RuleModule(CollectionNodeModule):
     """
@@ -79,13 +107,26 @@ class RuleModule(CollectionNodeModule):
             else:
                 return res
 
+    @check_precondition
     def get_nodes(self, gid, sid, did, scid, **kwargs):
         """
         Generate the collection node
         """
+        collection_count = 0
+        _id = kwargs['tid'] if 'tid' in kwargs else kwargs['vid']
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template("/".join(
+            [self.template_path, 'properties.sql']), tid=_id)
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
+
         assert ('tid' in kwargs or 'vid' in kwargs)
         yield self.generate_browser_collection_node(
-            kwargs['tid'] if 'tid' in kwargs else kwargs['vid']
+            kwargs['tid'] if 'tid' in kwargs else kwargs['vid'], collection_count
         )
 
     @property
@@ -188,35 +229,6 @@ class RuleView(PGChildNodeView):
             200, {'Content-Type': 'application/x-javascript'}
         )
 
-    def check_precondition(f):
-        """
-        This function will behave as a decorator which will check the
-        database connection before running a view. It will also attach
-        manager, conn & template_path properties to self
-        """
-
-        @wraps(f)
-        def wrap(*args, **kwargs):
-            # Here args[0] will hold self & kwargs will hold gid,sid,did
-            self = args[0]
-            self.manager = get_driver(
-                PG_DEFAULT_DRIVER).connection_manager(kwargs['sid'])
-            self.conn = self.manager.connection(did=kwargs['did'])
-
-            # If DB not connected then return error to browser
-            if not self.conn.connected():
-                return precondition_required(
-                    gettext(
-                        "Connection to the server has been lost!"
-                    )
-                )
-
-            self.datlastsysoid = self.manager.db_info[kwargs['did']]['datlastsysoid']
-            self.template_path = 'rules/sql'
-            return f(*args, **kwargs)
-
-        return wrap
-
     @check_precondition
     def list(self, gid, sid, did, scid, tid):
         """
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/triggers/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/triggers/__init__.py
index b3e4eec..f64b127 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/triggers/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/triggers/__init__.py
@@ -25,6 +25,67 @@ from pgadmin.utils.driver import get_driver
 from config import PG_DEFAULT_DRIVER
 
 
+def check_precondition(f):
+    """
+    This function will behave as a decorator which will checks
+    database connection before running view, it will also attaches
+    manager,conn & template_path properties to self
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold self & kwargs will hold gid,sid,did
+        self = args[0]
+        self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(
+            kwargs['sid']
+        )
+        self.conn = self.manager.connection(did=kwargs['did'])
+        # If DB not connected then return error to browser
+        if not self.conn.connected():
+            return precondition_required(
+                gettext(
+                    "Connection to the server has been lost!"
+                )
+            )
+
+        # We need datlastsysoid to check if current trigger is system trigger
+        self.datlastsysoid = self.manager.db_info[kwargs['did']]['datlastsysoid']
+
+        # we will set template path for sql scripts
+        self.template_path = 'trigger/sql/9.1_plus'
+        # Store server type
+        self.stype = self.manager.server_type
+        # We need parent's name eg table name and schema name
+        # when we create new trigger in update we can fetch it using
+        # property sql
+        SQL = render_template("/".join([self.template_path,
+                                        'get_parent.sql']),
+                              tid=kwargs['tid'])
+        status, rset = self.conn.execute_2darray(SQL)
+        if not status:
+            return internal_server_error(errormsg=rset)
+
+        for row in rset['rows']:
+            self.schema = row['schema']
+            self.table = row['table']
+
+        # Here we are storing trigger definition
+        # We will use it to check trigger type definition
+        self.trigger_definition = {
+            'TRIGGER_TYPE_ROW': (1 << 0),
+            'TRIGGER_TYPE_BEFORE': (1 << 1),
+            'TRIGGER_TYPE_INSERT': (1 << 2),
+            'TRIGGER_TYPE_DELETE': (1 << 3),
+            'TRIGGER_TYPE_UPDATE': (1 << 4),
+            'TRIGGER_TYPE_TRUNCATE': (1 << 5),
+            'TRIGGER_TYPE_INSTEAD': (1 << 6)
+        }
+
+        return f(*args, **kwargs)
+
+    return wrap
+
+
 class TriggerModule(CollectionNodeModule):
     """
      class TriggerModule(CollectionNodeModule)
@@ -91,13 +152,26 @@ class TriggerModule(CollectionNodeModule):
             # then true, othewise false
             return res
 
+    @check_precondition
     def get_nodes(self, gid, sid, did, scid, **kwargs):
         """
         Generate the collection node
         """
+        collection_count = 0
+        _id = kwargs['tid'] if 'tid' in kwargs else kwargs['vid']
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template("/".join([self.template_path,
+                                        'nodes.sql']), tid=_id)
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
+
         assert ('tid' in kwargs or 'vid' in kwargs)
         yield self.generate_browser_collection_node(
-            kwargs['tid'] if 'tid' in kwargs else kwargs['vid']
+            kwargs['tid'] if 'tid' in kwargs else kwargs['vid'], collection_count
         )
 
     @property
@@ -240,66 +314,6 @@ class TriggerView(PGChildNodeView):
         'enable': [{'put': 'enable_disable_trigger'}]
     })
 
-    def check_precondition(f):
-        """
-        This function will behave as a decorator which will checks
-        database connection before running view, it will also attaches
-        manager,conn & template_path properties to self
-        """
-
-        @wraps(f)
-        def wrap(*args, **kwargs):
-            # Here args[0] will hold self & kwargs will hold gid,sid,did
-            self = args[0]
-            self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(
-                kwargs['sid']
-            )
-            self.conn = self.manager.connection(did=kwargs['did'])
-            # If DB not connected then return error to browser
-            if not self.conn.connected():
-                return precondition_required(
-                    gettext(
-                        "Connection to the server has been lost!"
-                    )
-                )
-
-            # We need datlastsysoid to check if current trigger is system trigger
-            self.datlastsysoid = self.manager.db_info[kwargs['did']]['datlastsysoid']
-
-            # we will set template path for sql scripts
-            self.template_path = 'trigger/sql/9.1_plus'
-            # Store server type
-            self.server_type = self.manager.server_type
-            # We need parent's name eg table name and schema name
-            # when we create new trigger in update we can fetch it using
-            # property sql
-            SQL = render_template("/".join([self.template_path,
-                                            'get_parent.sql']),
-                                  tid=kwargs['tid'])
-            status, rset = self.conn.execute_2darray(SQL)
-            if not status:
-                return internal_server_error(errormsg=rset)
-
-            for row in rset['rows']:
-                self.schema = row['schema']
-                self.table = row['table']
-
-            # Here we are storing trigger definition
-            # We will use it to check trigger type definition
-            self.trigger_definition = {
-                'TRIGGER_TYPE_ROW': (1 << 0),
-                'TRIGGER_TYPE_BEFORE': (1 << 1),
-                'TRIGGER_TYPE_INSERT': (1 << 2),
-                'TRIGGER_TYPE_DELETE': (1 << 3),
-                'TRIGGER_TYPE_UPDATE': (1 << 4),
-                'TRIGGER_TYPE_TRUNCATE': (1 << 5),
-                'TRIGGER_TYPE_INSTEAD': (1 << 6)
-            }
-
-            return f(*args, **kwargs)
-
-        return wrap
-
     @check_precondition
     def get_trigger_functions(self, gid, sid, did, scid, tid, trid=None):
         """
@@ -312,7 +326,7 @@ class TriggerView(PGChildNodeView):
         # If server type is EDB-PPAS then we also need to add
         # inline edb-spl along with options fetched by below sql
 
-        if self.server_type == 'ppas':
+        if self.stype == 'ppas':
             res.append({
                 'label': 'Inline EDB-SPL',
                 'value': 'Inline EDB-SPL'
